routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home');

Auth::routes();

Route::group(['prefix' => 'admin',  'middleware' => 'auth'], function () {
    Route::resource('products', 'ProductController');
});

Route::get('product-detail/{id}', 'HomeController@productDetail')->name('product-detail');

Route::post('add-to-cart', 'HomeController@addToCart')->name('add-to-cart');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'price',
        'brand_id',
        'description',
        'image_id',
    ];

    /**
     * Get the brand that owns the product.
     */
    public function brand()
    {
        return $this->belongsTo(brand::class);
    }

    /**
     * Get the image that owns the product.
     */
    public function image()
    {
        return $this->hasOne(Image::class);
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Brand;
use App\Image;
use App\Product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Validator;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Cache::remember('products', 86400, function () {
            return Product::with('brand', 'image')->paginate(20);
        });

        $brands = Cache::remember('brands', 86400, function () {
            return Brand::get();
        });
    
        return view('admin.product.index', compact('products', 'brands'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'bail|required|string',
            'price' => 'bail|required|numeric',
            'image' => 'bail|required|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
            'brand_id' => 'bail|required|exists:brands,id',
            'description' => 'bail|required|string',
        ]);

        if ($validator->passes()) {

            $product = Product::create([
                'name' => $request->name,
                'price' => $request->price,
                'brand_id' => $request->brand_id,
                'description' => $request->description,
            ]);

            // save image
            if($product && isset($request->image)) {
                $file_name = $request->image->getClientOriginalName();
                $name = pathinfo($file_name, PATHINFO_FILENAME);
                $extension = pathinfo($file_name, PATHINFO_EXTENSION);

                $imageName = $name.'_'.time() .'.'. $extension;  
                $request->image->move(public_path('images'), $imageName);

                // save image model
                $image = new Image(['product_id' => $product->id, 'filename' => $imageName]);
                $product->image()->save($image);
            }

            return back()->with('success', __('Created successfully'));
        } else {
            return back()->withErrors($validator);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        $brands = Brand::get();
        return view('admin.product.edit', compact('product', 'brands'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'bail|required|string',
            'price' => 'bail|required|numeric',
            'image' => 'bail|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
            'brand_id' => 'bail|required|exists:brands,id',
            'description' => 'bail|required|string',
        ]);

        if ($validator->passes()) {

            if(isset($request->image)) {

                // delete old image
                if(file_exists(public_path('images/' . $product->image->filename))) {
                    unlink(public_path('images/' . $product->image->filename));
                }

                // save image
                $file_name = $request->image->getClientOriginalName();
                $name = pathinfo($file_name, PATHINFO_FILENAME);
                $extension = pathinfo($file_name, PATHINFO_EXTENSION);

                $imageName = $name.'_'.time() .'.'. $extension;  
                $request->image->move(public_path('images'), $imageName);

                $product->image()->update([
                    'filename' => $imageName
                ]);
            }
            
            $product->update($request->only('name', 'price', 'brand_id', 'description'));

            return back()->with('success', __('Updated successfully'));
        } else {
            return back()->withErrors($validator);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();

        return back()->with('success', __('Deleted successfully'));
    }
}

resources/views/admin/product/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">

    @include('admin.includes.alert')

    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                
                <form action="{{ route('products.update', $product) }}" method="POST" enctype="multipart/form-data">
                    @method('PATCH')
                    @csrf
                    
                    <div class="modal-body">
                        <div class="mb-3">
                            <label for="inputName" class="form-label">Name</label>
                            <input type="text" name="name" class="form-control" id="inputName" value="{{ $product->name }}">
                        </div>
                        <div class="mb-3">
                            <label for="inputPrice" class="form-label">Price</label>
                            <input type="text" name="price" class="form-control" id="inputPrice" value="{{ $product->price }}">
                        </div>
                        <div class="mb-3">
                            <label for="inputImage" class="form-label">Image</label>
                            <input type="file" name="image" class="form-control-file" id="inputImage">
                            @if (isset($product->image->filename))
                                <img class="img-thumbnail" src="{{ asset('images/' . $product->image->filename) }}" style="max-width: 100px;">
                            @endif
                        </div>
                        <div class="mb-3">
                            <label for="inputBrand" class="form-label">Brand</label>
                            <select name="brand_id" class="form-control" id="inputBrand">
                                <option>Selected</option>
                                @foreach ($brands as $item)
                                    <option value="{{ $item->id }}" {{ ($product->brand->id == $item->id) ? 'selected' : '' }}>{{ $item->name }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="inputDesc" class="form-label">Description</label>
                            <textarea name="description" class="form-control" id="inputDesc" rows="3">{{ $product->description }}</textarea>
                        </div>
                        
                    </div>
                    <div class="modal-footer">
                        <a type="button" href="{{ route('products.index') }}" class="btn btn-secondary" data-dismiss="modal">Back</a>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </div>
                </form>

            </div>
        </div>
    </div>
</div>

@endsection

@push('scripts')
    <script type="text/javascript">
        

    </script>
@endpush

resources/views/admin/product/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">

    @include('admin.includes.alert')

    <a type="button" class="btn btn-success" data-toggle="modal" data-target=".bd-modal-add-new">Add new</a>

    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <table class="table">
                    <thead>
                      <tr>
                        <th scope="col">#</th>
                        <th scope="col">Name</th>
                        <th scope="col">Price</th>
                        <th scope="col">Brand</th>
                        <th scope="col">Image</th>
                        <th></th>
                      </tr>
                    </thead>

                    <tbody>
                        @foreach ($products as $key => $product)
                            <tr>
                                <th scope="row">{{ $key + 1 }}</th>
                                <td>{{ $product->name }}</td>
                                <td>{{ $product->price }}</td>
                                <td>{{ isset($product->brand->name) ? $product->brand->name : '' }}</td>
                                <td>
                                    @if (isset($product->image->filename))
                                        <img class="img-thumbnail" src="{{ asset('images/' . $product->image->filename) }}" style="max-width: 100px;">
                                    @endif
                                </td>
                                <td class="text-right">
                                    <a type="button" href="{{ route('products.edit', $product) }}" class="btn btn-primary btnEditProduct">edit</a>
                                    
                                    <form class="d-inline" action="{{route('products.destroy', $product)}}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        
                                        <button type="submit" class="btn btn-danger">delete</button>
                                    </form>
                                </td>
                            </tr>
                        @endforeach                    
                    </tbody>
                </table>

                @if(!count($products))
                    <p class="px-3">No data!</p>
                @endif

            </div>

            {!! $products->links() !!}
        </div>
    </div>
</div>


{{-- modal add new product --}}
<div class="modal fade bd-modal-add-new" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Add new product</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            
            <form action="{{ route('products.store') }}" method="POST" enctype="multipart/form-data">
                @csrf
                
                <div class="modal-body">
                    <div class="mb-3">
                        <label for="inputName" class="form-label">Name</label>
                        <input type="text" name="name" class="form-control" id="inputName">
                    </div>
                    <div class="mb-3">
                        <label for="inputPrice" class="form-label">Price</label>
                        <input type="text" name="price" class="form-control" id="inputPrice">
                    </div>
                    <div class="mb-3">
                        <label for="inputImage" class="form-label">Image</label>
                        <input type="file" name="image" class="form-control-file" id="inputImage">
                    </div>
                    <div class="mb-3">
                        <label for="inputBrand" class="form-label">Brand</label>
                        <select name="brand_id" class="form-control" id="inputBrand">
                            <option>Selected</option>
                            @foreach ($brands as $item)
                                <option value="{{ $item->id }}">{{ $item->name }}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="mb-3">
                        <label for="inputDesc" class="form-label">Description</label>
                        <textarea name="description" class="form-control" id="inputDesc" rows="3"></textarea>
                    </div>
                    
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
            </form>
        </div>
    </div>
</div>

@endsection